//
//  BoardCell.m
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "BoardCellKoma.h"
#import "BoardCell.h"


@implementation BoardCell

// B
- (id)initBoardCell:(int)x :(int)y :(int)kind :(BOOL)nari {
    self = [super init];
    
    _x = x;
    _y = y;
    _count = 0;
    _komaKind = kind;

    switch (kind) {
        case SENTE_OU:
        case SENTE_HISYA:	
        case SENTE_KAKU:
        case SENTE_KIN:
        case SENTE_GIN:
        case SENTE_KEIMA:
        case SENTE_KYOUSYA:
        case SENTE_FU:
        case SENTE_RYU:
        case SENTE_UMA:
        case SENTE_NARIGIN:
        case SENTE_NARIKEI:
        case SENTE_NARIKYOU:
        case SENTE_TO:
        case GOTE_OU:
        case GOTE_HISYA:	
        case GOTE_KAKU:
        case GOTE_KIN:
        case GOTE_GIN:
        case GOTE_KEIMA:
        case GOTE_KYOUSYA:
        case GOTE_FU:
        case GOTE_RYU:
        case GOTE_UMA:
        case GOTE_NARIGIN:
        case GOTE_NARIKEI:
        case GOTE_NARIKYOU:
        case GOTE_TO:
            _count = 1;
            break;
    }

    return self;
}

- (id)initBoardCell:(BoardCell *)cell {
 
       self = [super init];
    
    _x = [cell boardCellX];
    _y = [cell boardCellY];
    _count = [cell boardCellCount];
    _komaKind = [cell boardCellKomaKind];

    return self;
}

-(int)boardCellX {
    return _x;
}

-(int)boardCellY {
    return _y;
}

-(int)boardCellCount {
    return _count;
}

// ̎ށB
-(int)boardCellKomaKind {
    return _komaKind;
}

-(void)setBoardCellX:(int)x {
    _x = x;
}

-(void)setBoardCellY:(int)y {
    _y = y;
}

-(void)setBoardCellCount:(int)count {
    _count = count;
}

-(void)setBoardCellKomaKind:(int)kind {
    _komaKind = kind;
}

// Rs[B
- (void)boardCellCopy:(BoardCell *)cell {
    _x = [cell boardCellX];
    _y = [cell boardCellY];
    _komaKind = [cell boardCellKomaKind];
    _count = [cell boardCellCount];
}

// countȊORs[B
- (void)boardCellCopyExceptCount:(BoardCell *)cell {
    _x = [cell boardCellX];
    _y = [cell boardCellY];
    _komaKind = [cell boardCellKomaKind];
}

// B
- (void)eraseBoardCell {
    _komaKind = KOMA_NASHI;
    _count = 0;
}

// B
- (void)promote {
       switch (_komaKind) {
        case SENTE_HISYA:	
            _komaKind = SENTE_RYU;
            break;
        case SENTE_KAKU:
            _komaKind = SENTE_UMA;
            break;
        case SENTE_GIN:
            _komaKind = SENTE_NARIGIN;
            break;
        case SENTE_KEIMA:
            _komaKind = SENTE_NARIKEI;
            break;
        case SENTE_KYOUSYA:
            _komaKind = SENTE_NARIKYOU;
            break;
        case SENTE_FU:
            _komaKind = SENTE_TO;
            break;
        case GOTE_HISYA:	
            _komaKind = GOTE_RYU;
            break;
        case GOTE_KAKU:
            _komaKind = GOTE_UMA;
            break;
        case GOTE_GIN:
            _komaKind = GOTE_NARIGIN;
            break;
        case GOTE_KEIMA:
            _komaKind = GOTE_NARIKEI;
            break;
        case GOTE_KYOUSYA:
            _komaKind = GOTE_NARIKYOU;
            break;
        case GOTE_FU:
            _komaKind = GOTE_TO;
            break;
    }
}

// 邱Ƃł邩
- (BOOL)canPromote:(int)x :(int)y {
    BOOL flag = NO;

    if (((y <= 3) && (_komaKind < 0)) || ((y >=7) && (_komaKind > 0)) || 
        ((_y <= 3) && (_komaKind < 0)) || ((_y >= 7) && (_komaKind > 0))) {
       switch (_komaKind) {
            case SENTE_HISYA:	
            case SENTE_KAKU:
            case SENTE_GIN:
            case SENTE_KEIMA:
            case SENTE_KYOUSYA:
            case SENTE_FU:
            case GOTE_HISYA:	
            case GOTE_KAKU:
            case GOTE_GIN:
            case GOTE_KEIMA:
            case GOTE_KYOUSYA:
            case GOTE_FU:
            flag = YES;
            break;
        }
    }
    return flag;
}

// IɐȂƂȂH
- (BOOL)canAutoPromote:(int)x :(int)y {
    BOOL flag = NO;

    if ((y == 9) && (_komaKind == SENTE_FU)) {
        flag = YES;
    } else if ((y == 9) && (_komaKind == SENTE_KYOUSYA)) {
        flag = YES;
    } else if ((y == 1) && (_komaKind == GOTE_FU)) {
        flag = YES;
    } else if ((y == 1) && (_komaKind == GOTE_KYOUSYA)) {
        flag = YES;
    } else if ((y > 7) && (_komaKind == SENTE_KEIMA)) {
        flag = YES;
    } else if ((y < 3) && (_komaKind == GOTE_KEIMA)) {
        flag = YES;
    }
    return flag;
}

// Ă߂B
// Ղ̈ʒuύXB
- (void)reversePromote {
    _komaKind = -_komaKind;

    switch (_komaKind) {
        case SENTE_OU:
            _komaKind = KOMA_NASHI;
            _count = 0;
            break;
        case SENTE_RYU:
            _komaKind = SENTE_HISYA;
        case SENTE_HISYA:	
            _x = 11;
            _y = 4;
            break;
        case SENTE_UMA:
            _komaKind = SENTE_KAKU;
        case SENTE_KAKU:
            _x = 13;
            _y = 4;
            break;
        case SENTE_KIN:
            _x = 11;
            _y = 3;
            break;
        case SENTE_NARIGIN:
            _komaKind = SENTE_GIN;
        case SENTE_GIN:
            _x = 13;
            _y = 3;
            break;
        case SENTE_NARIKEI:
            _komaKind = SENTE_KEIMA;
        case SENTE_KEIMA:
            _x = 11;
            _y = 2;
            break;
        case SENTE_NARIKYOU:
            _komaKind = SENTE_KYOUSYA;
        case SENTE_KYOUSYA:
            _x = 13;
            _y = 2;
            break;
        case SENTE_TO:
            _komaKind = SENTE_FU;
        case SENTE_FU:
            _x = 11;
            _y = 1;
            break;

        case GOTE_OU:
            _komaKind = KOMA_NASHI;
            _count = 0;
            break;
        case GOTE_RYU:
            _komaKind = GOTE_HISYA;
        case GOTE_HISYA:	
            _x = 11;
            _y = 6;
            break;
        case GOTE_UMA:
            _komaKind = GOTE_KAKU;
        case GOTE_KAKU:
            _x = 13;
            _y = 6;
            break;
        case GOTE_KIN:
            _x = 11;
            _y = 7;
            break;
        case GOTE_NARIGIN:
            _komaKind = GOTE_GIN;
        case GOTE_GIN:
            _x = 13;
            _y = 7;
            break;
        case GOTE_NARIKEI:
            _komaKind = GOTE_KEIMA;
        case GOTE_KEIMA:
            _x = 11;
            _y = 8;
            break;
        case GOTE_NARIKYOU:
            _komaKind = GOTE_KYOUSYA;
        case GOTE_KYOUSYA:
            _x = 13;
            _y = 8;
            break;
        case GOTE_TO:
            _komaKind = GOTE_FU;
        case GOTE_FU:
            _x = 11;
            _y = 9;
            break;
    }
}

// ݁B
- (void)encodeWithCoder:(NSCoder *)encoder {
 //   [super encodeWithCoder:encoder];
    [encoder encodeValueOfObjCType:@encode(int) at:&_komaKind];
    [encoder encodeValueOfObjCType:@encode(int) at:&_x];
    [encoder encodeValueOfObjCType:@encode(int) at:&_y];
    [encoder encodeValueOfObjCType:@encode(int) at:&_count];
}

// ǂݍ݁B
- (id)initWithCoder:(NSCoder *)decoder {
 
    self = [super init];
 
    [decoder decodeValueOfObjCType:@encode(int) at:&_komaKind];
    [decoder decodeValueOfObjCType:@encode(int) at:&_x];
    [decoder decodeValueOfObjCType:@encode(int) at:&_y];
    [decoder decodeValueOfObjCType:@encode(int) at:&_count];    
    
    return self;
}

// BoardCell̏\B
- (void)printBoardCell {
    NSLog(@"koma:%d x:%d y:%d count:%d", _komaKind, _x, _y, _count);
}

// ̉B
- (void)dealloc {
    [super dealloc];
}


@end
