//
//  BoardView.m
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "BoardCellKoma.h"
#import "BoardView.h"
#import "Adapter.h"
#import "BoardManager.h"
#import "YKifController.h"

@implementation BoardView

- (id)initWithFrame:(NSRect)frame {
    NSArray *pboardTypes;
    
    _editFlag = NO;
    self = [super initWithFrame:frame];
    
    pboardTypes = [NSArray arrayWithObject: NSTIFFPboardType];
    [self registerForDraggedTypes:pboardTypes];
 
    return self;
}

- (BOOL)editFlag {
    return _editFlag;
}

- (void)setEditFlag:(BOOL)flag {
    _editFlag = flag;
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender {
    NSPasteboard *board;
    NSPoint pos;
    int x, y;

//    NSLog(@"perform");
    
    board = [sender draggingPasteboard]; 

    pos = [sender draggingLocation];
    pos = [self convertPoint:pos fromView:nil];

    x = (int)(pos.x/KOMA_WIDTH);
    y = (int)(pos.y/KOMA_HEIGHT);
 
    [_adapter moveBoardDrag:x :y];

    [self setNeedsDisplay:YES];

    return YES;
}

- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender {
    NSPasteboard *board;
    NSPoint pos;
    int x, y;

//    NSLog(@"Enter");
    
    board = [sender draggingPasteboard]; 

    pos = [sender draggingLocation];
    pos = [self convertPoint:pos fromView:nil];

    x = (int)(pos.x/KOMA_WIDTH);
    y = (int)(pos.y/KOMA_HEIGHT);
 
    [_adapter enterBoardDrag:x :y];
    [self setNeedsDisplay:YES];
    
    return NSDragOperationGeneric;
}

- (unsigned int)draggingUpdated:(id <NSDraggingInfo>)sender {
//    NSLog(@"Update");
    return NSDragOperationGeneric;
}

- (void)draggingExited:(id <NSDraggingInfo>)sender {
//    NSLog(@"Exit");
    [_adapter exitBoardDrag];
    [self setNeedsDisplay:YES];
}

- (void)draggingEnded:(id <NSDraggingInfo>)sender {
//    NSLog(@"Ended");
}

- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender {
//   NSLog(@"prepare");
    return YES;

}

- (void)concludeDragOperation:(id <NSDraggingInfo>)sender {
//    NSLog(@"conclude");
}

// }EXNbN̏B
- (void)mouseDown:(NSEvent *)theEvent {
    NSSize size;
    NSPoint mouseLoc;
    NSPasteboard *pboard;
    NSImage *image;
    BOOL flag = NO;
    int komaKind;
    int startKomaKind;
    int x,y;
    int index;
    int mod;

    mouseLoc = [self convertPoint:[theEvent locationInWindow] fromView: nil];
    
    x = (int)(mouseLoc.x / KOMA_WIDTH);
    y = (int)(mouseLoc.y / KOMA_HEIGHT);
    
    if (_editFlag == YES) {
        image = [_adapter getKomaImage:x :y];
        komaKind = [_adapter getKomaKind:x :y];
        index = [_ykifController indexKif];
        mod = (index / 4) % 2;

        if (index != 0) {
            startKomaKind = [_adapter startKomaKind];
 
            if ((komaKind == 0) || (komaKind == KOMA_WAKU)) {
                flag = NO;
            } else if ((startKomaKind > 0) && (komaKind > 0) && (mod == 0)) {
                flag = YES;
            } else if ((startKomaKind > 0) && (komaKind < 0)  && (mod == 1)) {
                flag = YES;
            } else if ((startKomaKind < 0) && (komaKind < 0) && (mod == 0)) {
                flag = YES;
            } else if ((startKomaKind < 0) && (komaKind > 0) && (mod == 1)) {      
                flag = YES;
            }
        }

        if ((flag == YES) || (index == 0)) {
            if (image != nil) {
                pboard = [NSPasteboard pasteboardWithName:NSDragPboard];
                [pboard declareTypes:[NSArray arrayWithObject:NSTIFFPboardType] 				owner:self];
                [pboard setData:[image TIFFRepresentation] forType:NSTIFFPboardType];

                size = [image size];
                mouseLoc.x -= size.width/2;
                mouseLoc.y -= size.height/2;
 
                // hbOB
                [self dragImage:image at:mouseLoc offset:NSMakeSize(0,0)
                event:theEvent pasteboard:pboard source:self slideBack:NO];
            }
        }
    }
}

- (void)drawRect:(NSRect)rect {
    [_boardManager drawBoard];
}

@end
