//
//  YKifController.h
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define FILE_EXT	@"kif data"
#define FILE_XEXT	@"xshogi kif data"

@class BoardCell;

@interface YKifController : NSObject {
    IBOutlet id _boardManager;
    IBOutlet id _boardView;
    IBOutlet id _boardWindow;
    IBOutlet id _adapter;
    IBOutlet id _newWindow;
    IBOutlet id _newSenteTextField;
    IBOutlet id _newGoteTextField;
    IBOutlet id _newTeaiwari;
    IBOutlet id _shogibanWindowController;
    IBOutlet id _xkifController;
       
    int _indexKif;
    NSMutableArray *_kifArray;
    NSMutableDictionary *_kifData;
    NSString *_senteName;
    NSString *_goteName;
    NSNumber *_teaiwari;
    NSString *_date;
    NSString *_path;
}

- (NSString *)gameSenteName;
- (NSString *)gameGoteName;
- (NSString *)gameDate;

- (void)newKif;

- (IBAction)endNewYes:(id)sender;
- (IBAction)endNewNo:(id)sender;
- (void)sheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (void)doOpen:(NSData *)data :(NSString *)type;
- (NSData *)doSave;

- (void)selectedRotateStepChange:(NSNotification *)notification;
- (void)selectedFrontStepChange:(NSNotification *)notification;
- (void)selectedBackStepChange:(NSNotification *)notification;
- (void)selectedFrontStep2Change:(NSNotification *)notification;
- (void)selectedBackStep2Change:(NSNotification *)notification;

- (void)mainWindowChanged:(NSNotification *)notification;

- (void)doFrontStepKif;
- (void)doBackStepKif;

- (int)startKomaKind;
- (int)indexKif;
- (int)kifArrayMax;

- (void)addKifController:(BoardCell *)selectSource :(BoardCell *)selectDestination
    :(BoardCell *)placeSource :(BoardCell *)placeDestination;
- (void)removeKifController;

- (BOOL)validateMenuItem:(NSMenuItem *)anItem :(NSString *)type;
- (void)editKif;
- (void)editEndKif;
- (void)printKifController;


@end
